﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.Net.Sockets;
using System.Threading;
using System.IO;
namespace ChatRoomClient
{
    public partial class FChatCilent : Form
    {
        public FChatCilent()
        {
            InitializeComponent();
            TextBox.CheckForIllegalCrossThreadCalls = false;
        }
        //客户端套接字
        Socket socketCilent = null;
        //负责接收的线程
        Thread thread = null;
        private void btnConnection_Click(object sender, EventArgs e)
        {
            IPAddress ipadress = IPAddress.Parse(txtIPAdress.Text.Trim());
            IPEndPoint endpoint = new IPEndPoint(ipadress, int.Parse(txtPort.Text.Trim()));
            //创建实例
            socketCilent = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
            try
            {
                socketCilent.Connect(endpoint);//连接服务器
                thread = new Thread(RecMsg);
                thread.IsBackground = true;
                thread.Start();
            }
            catch (SocketException ex)
            {
                ShowMsg("连接时产生异常："+ex.Message);                
            }
            catch (Exception ex)
            {
                ShowMsg("连接时产生异常：" + ex.Message);
            }

        }

        private void btnSend_Click(object sender, EventArgs e)
        {
            string Msg = txtmsg.Text.Trim();
            byte[] SendMsg = System.Text.Encoding.UTF8.GetBytes(Msg);
            socketCilent.Send(SendMsg);
            ShowMsg("发送了数据" + Msg);
        }
        void RecMsg()
        {
            while (true)
            {
                //准备2M的字节数组用来存储
                byte[] Msg = new byte[1024 * 1024 * 2];
                int lenth = socketCilent.Receive(Msg);
                if (Msg[0] == 0)//接收到文本
                {                    
                    //将接收到的字节数组转换回字符串
                    string Str = System.Text.Encoding.UTF8.GetString(Msg, 1, lenth-1);
                    ShowMsg(Str);
                }
                else if (Msg[0] == 1)//接收文件时
                {
                    SaveFileDialog sfd = new SaveFileDialog();
                    if (sfd.ShowDialog() == DialogResult.OK)
                    {
                        string SavePath = sfd.FileName;
                        using(FileStream fs=new FileStream(SavePath,FileMode.Create))
	                    {
                            fs.Write(Msg, 1, lenth - 1);
                            ShowMsg("文件保存成功：" + SavePath);
	                    }
                    }
                }
                else if (Msg[0] == 2)//接收在线列表
                {
                    string str = System.Text.Encoding.UTF8.GetString(Msg, 1, lenth - 1);
                    Onlinelist.Items.Add(str);
                    
                }
            }
        }
        void ShowMsg(string msg)
        {
            txtdisp.AppendText(msg + "\r\n");
        }
    }
}
