﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Net;//IPAdress,IPEndPoint(ip和端口类)类
using System.Net.Sockets;
using System.Windows.Forms;
using System.Threading;
using System.IO;

//发送数据时，当数据开头字节为0时 为发送 文字，当数据开头为1时 为发送文件 ，当数据开头为2 为发送在线列表使客户端识别
//服务端往客户端发送信息
namespace ChatSever
{
    public partial class FChatSever : Form
    {
        public FChatSever()
        {
            InitializeComponent();
            TextBox.CheckForIllegalCrossThreadCalls = false;//关闭对文本框的挂线程检查
        }
        Thread threadWatch = null;//负责监听请求的线程
        Socket socketWatch = null;
        //Thread threadRecMsg = null;//负责接收数据的线程

        private void btnStart_Click(object sender, EventArgs e)
        {
            //创建服务端 负责监听的套接字，参数（使用IP4寻址协议，使用流式连接，使用TCP协议传输数据）
            socketWatch = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
            //获取文本框中的IP地址对象
            IPAddress adress = IPAddress.Parse(txt_IPAdress.Text.Trim());
            IPEndPoint endpoint = new IPEndPoint(adress,int.Parse(txtPort.Text.Trim()));
            try
            {
                socketWatch.Bind(endpoint);
                //设置监听队列的长度（一次处理10次请求）
                socketWatch.Listen(10);
                threadWatch = new Thread(WatchConnecting);
                threadWatch.IsBackground = true;//设置被后台线程
                threadWatch.Start();
                ShowMsg("监听成功");
            }
            catch (SocketException ex)
            {
                ShowMsg(ex.Message);
            }
            catch (Exception ex)
            {
                ShowMsg(ex.Message);
            }


        }
        //Socket sokConnection = null;使用集合，处理多个客户端连接到服务端问题
        Dictionary<string, Socket> dict = new Dictionary<string, Socket>();
        //使用集合，为每一个客户端发送消息创建一个接收线程
        Dictionary<string, Thread> dicthr = new Dictionary<string, Thread>();
        private void btnSend_Click(object sender, EventArgs e)
        {
            string SendMsg = txtmsg.Text.Trim();
            byte[] Msg = System.Text.Encoding.Default.GetBytes(SendMsg);
            byte[] NewMsg = new byte[Msg.Length + 1];
            NewMsg[0] = 0;
            Buffer.BlockCopy(Msg, 0, NewMsg, 1, Msg.Length);
            //sokConnection.Send(Msg);
            if (OnlineList.SelectedItems.Count == 1)
            {
                //获得列表中远程IP端口（KEY）
                string SendKey = OnlineList.Text;
                //通过KEY找到对应的与客户端通信的套接字，调用SEND方法，发送数据
                try
                {
                    dict[SendKey].Send(NewMsg);
                    ShowMsg("发送了数据" + SendMsg);
                }
                catch (SocketException ex)
                {
                    ShowMsg("发送时：" + ex.Message);
                    
                }
                catch (Exception ex)
                {
                    ShowMsg("发送时：" + ex.Message);

                }
            }
        }
        private void btnGroupSend_Click(object sender, EventArgs e)
        {
            string SendMsg = txtmsg.Text.Trim();
            byte[] Msg = System.Text.Encoding.Default.GetBytes(SendMsg);
            byte[] NewMsg = new byte[Msg.Length + 1];
            NewMsg[0] = 0;
            Buffer.BlockCopy(Msg, 0, NewMsg, 1, Msg.Length);
            if (OnlineList.SelectedItems.Count >= 1)
            {
                foreach (string s in OnlineList.SelectedItems)
                {
                    try
                    {
                        dict[s].Send(NewMsg);
                    }
                    catch (SocketException ex)
                    {
                        ShowMsg("发送时异常："+ex.Message);
                        return;
                    }
                    catch (Exception ex)
                    {
                        ShowMsg("发送时异常：" + ex.Message);
                        return;
                    }
                }
                ShowMsg("发送了数据：" + SendMsg);
            }
        }
        private void btnSendFile_Click(object sender, EventArgs e)
        {
            using (FileStream fs = new FileStream(txtFileName.Text, FileMode.Open))
            {
                byte[] arrFile = new byte[1024 * 1024 * 2];
                int lenth = fs.Read(arrFile, 0, arrFile.Length);
                byte[] arrFileSend = new byte[arrFile.Length + 1];
                arrFileSend[0] = 1;
                Buffer.BlockCopy(arrFile, 0, arrFileSend, 1, lenth);
                if (OnlineList.SelectedItems.Count == 1)
                {
                    string SendKey = OnlineList.Text;
                    try
                    {
                        dict[SendKey].Send(arrFileSend);
                    }

                    catch (SocketException ex)
                    {
                        ShowMsg("发送时：" + ex.Message);                   
                    }
                    catch (Exception ex)
                    {
                        ShowMsg("发送时：" + ex.Message);
                    }
                }
                else
                {
                    ShowMsg("您未选中客户端或选择了多个客户端");
                }
            }
        }
        #region 选择文件---btnChoiseFile_Click
        /// <summary>
        /// 选择文件
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e">btnChoiseFile_Click</param>
        private void btnChoiseFile_Click(object sender, EventArgs e)
        {
            OpenFileDialog opd = new OpenFileDialog();
            if (opd.ShowDialog() == DialogResult.OK)
            {
                txtFileName.Text = opd.FileName;
            }
        }
        #endregion

        #region 显示信息ShowMsg
        /// <summary>
       /// 显示信息
       /// </summary>
       /// <param name="msg">msg</param>
        void ShowMsg(string msg)
        {
            txtdisp.AppendText(msg + "\r\n");
        }
        #endregion



        #region 监听请求WatchConnecting
        /// <summary>
        /// 监听请求
        /// </summary>
        void WatchConnecting()
        {
            while (true)
            {
                //开始监听客户端请求 Accept方法，阻断请求，
                try
                {
                    Socket sokConnection = socketWatch.Accept();//一但监听到客户端请求，就返回一个负责和该客户端通信的套接字
                    //将与客户端连接的套接字端详socketConnection存储到字典（键值对）集合中，并以客户端IP端口作为键
                    dict.Add(sokConnection.RemoteEndPoint.ToString(), sokConnection);
                    //创建一个线程来接受客户端信息
                    Thread thr = new Thread(RecMsg);
                    thr.IsBackground = true;
                    thr.Start(sokConnection);
                    dicthr.Add(sokConnection.RemoteEndPoint.ToString(), thr);
                    //在列表中添加已经连接的客户端套接字IP端口字符串，作为客户端唯一标识
                    OnlineList.Items.Add(sokConnection.RemoteEndPoint.ToString());
                    //将在线列表发送给客户端
                    foreach (Socket s in dict.Values)
                    {
                        foreach (string x in OnlineList.Items)
                        {
                            if (x != s.RemoteEndPoint.ToString())
                            {
                                    byte[] IpPoint = System.Text.Encoding.Default.GetBytes(x);
                                    byte[] NewPoint = new byte[IpPoint.Length + 1];
                                    NewPoint[0] = 2;
                                    Buffer.BlockCopy(IpPoint, 0, NewPoint, 1, IpPoint.Length);
                                    s.Send(NewPoint);                               
                            }
                        }
                    }
                    ShowMsg("启动成功" + sokConnection.RemoteEndPoint.ToString());
                }
                catch (SocketException ex)
                {
                    ShowMsg("异常："+ex.Message);
                    break;
                }
                catch (Exception ex)
                {
                    ShowMsg("异常：" + ex.Message);
                    break;
                }              
            }

        }
        #endregion


        #region 接收信息---------RecMsg
        /// <summary>
        /// 接收信息
        /// </summary>
        /// <param name="sokConnectionPara">sokConnectionPara</param>
        void RecMsg(object sokConnectionPara)
        {
            Socket socketCilent = sokConnectionPara as Socket;
            while (true)
            {
                //准备2M的字节数组用来存储
                byte[] Msg = new byte[1024 * 1024 * 2];
                int lenth = -1;
                try
                {
                     lenth = socketCilent.Receive(Msg);
                }
                catch (SocketException ex)
                {
                    ShowMsg("异常："+ex.Message);
                    dict.Remove(socketCilent.RemoteEndPoint.ToString());
                    dicthr.Remove(socketCilent.RemoteEndPoint.ToString());
                    OnlineList.Items.Remove(socketCilent.RemoteEndPoint.ToString());
                    break;                    
                }
                catch (Exception ex)
                {
                    ShowMsg("异常：" + ex.Message);
                    break;
                }
                //将接收到的字节数组转换回字符串
                string Str = System.Text.Encoding.UTF8.GetString(Msg, 0, lenth);
                ShowMsg("消息来自于"+socketCilent.RemoteEndPoint.ToString()+"\r\n"+Str);
            }
        }

        #endregion


    }
}
